#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "include.h"

static void print_usage_message(char *argv0) {
	fprintf(stderr, "usage: %s count|cluster|map|tabulate [OPTIONS]...\n", argv0);
}

/**
 * Main entry point of the program
 * Will simply read acknowledge the barseq request:
 * 	Either count, cluster, map, or tabulate
 * Will then simply redirect the request to the
 * appropriate entry points of the submethods:
 * 	count_main, cluster_main, map_main, tabulate_main
 */
int main(int argc, char **argv) {
	if (argc < 2) {
		print_usage_message(argv[0]);
		exit(1);
	}
	
	//prepared to call a subroutine
	int passed_argc = argc - 1;
	char **passed_argv = &argv[1];
	
	if (strcmp(argv[1], "count") == 0) {
		return count_main(passed_argc, passed_argv);
	} else if (strcmp(argv[1], "cluster") == 0) {
		return cluster_main(passed_argc, passed_argv);
	} else if (strcmp(argv[1], "map") == 0) {
		return map_main(passed_argc, passed_argv);
	} else if (strcmp(argv[1], "tabulate") == 0) {
		return tabulate_main(passed_argc, passed_argv);
	} else {
		print_usage_message(argv[0]);
		exit(1);
	}
	
	return 0;
};
