/* Backend hashing by array of entries */

#ifndef HASH_H
#define HASH_H

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "list.h"

/* Number of hash slots in the table, can be increased but this
   was found to be optimal through experimenting */
#define	HASH_SLOTS	(1 << 20)

/* The hash table is an array of lists, which are an array of entries */
struct hash {
	list** slots;
};

typedef struct hash hash;

long hash_slot(char*);
int hash_slot_nmer(char*,int);
hash* hash_create();
void hash_destroy(hash*);
int hash_lookup(hash*,char*);
void hash_increment(hash*,char*);
void hash_decrement(hash*,char*);
void hash_set_value(hash*,char*,int);
int hash_entries(hash*);
void hash_create_entry(hash*,char*,int);
void hash_remove_entry(hash*,char*);

entry* hash_sorted_entries(hash*);
int entry_comparator(const void*,const void*);

#endif
