#ifndef LIST_H
#define LIST_H

/* Entries are a (key, value) pair */
struct entry {
	char *key;
	int value;
};

typedef struct entry entry;

/* Lists are dynamic arrays of entries */
struct list {
	entry **entries;
	int size;
	int max_size;
	int sorted;
};

typedef struct list list;

list* list_create();
void list_destroy(list*);
int list_find(list*,char*);
void list_increment(list*,char*);
void list_increment_n(list*,char*,int);
void list_decrement(list*,char*);
void list_set_value(list*,char*,int);
void list_create_entry(list*,char*,int);
int list_remove_entry(list*,char*);

void list_sort_by_value(list*);
void list_sort_by_key(list*);
int indirect_entry_comparator(const void*,const void*);
int indirect_entry_key_comparator(const void*, const void*);

#endif
